<?php
/*
 * Created on 30 janv. 07
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */

if (!defined('IN_COPPERMINE')) { die('Not in Coppermine...');}
if (!defined('JUPLOAD_PHP')) { die('Not in Jupload...');}


//####################################################################################################
//#################################  INTERNAL VARIABLES  #############################################
//####################################################################################################

$dateTime = getDate();

$configFileHeader = <<<EOS
<?php
/**
 * Caution: This file is generated from the jupload configuration page of JUpload.
 * 
 * You can update it: all modifications on value of valid Jupload parameters will be kept. Comments will be lost
 * if you save the configuration through the jupload configuration page.
 * 
 * To go to the jupload configuration page :
 * - Connect as an admin,
 * - Click on configuration, then General, then 'plugin management',
 * - Click on the 'Jupload Configuration' button that should appear, if JUpload is installed.
 * 
 * TODO: remove the html tags in this file. One day, perhaps ...
 * 
 */



EOS
;



$hint = <<<EOS
<HR>
<B><a name="Hints">Configuration hints</a></B>
<BR><BR>
You will find below the list of all JUpload configuration parameters, with a detailled explanation of each one. 
These parameters are stored in the plugins/jupload/user/config.inc.php file. It is kept when you upgrade to a 
new JUpload  version, through the plugin management page, or with FTP: this file is not packaged with JUpload 
releases.
<BR><BR>
You will find below <B>two typical configurations</B>:
<DIR
	<LI><B>Configuration to speed up the upload.</B> This configuration is a good replacement for <U>batch upload</U>, 
	and can <U>replace easily the xp_publish script</U>, that is no more available for Vista. The maximum 
	picture/file size is controled only by the maxPictureSize Coppermine configuration parameters. 
		<DIR>
			<LI>In Coppermine configuration, put in the maximum file size a value big enough to allow upload of 
			your bigger files, even if they are bigger than your server maxUploadSize. To upload files bigger than 
			the server maxUploadSize, you will have to use JUpload (and its chunk function, see below).
			<LI>In Jupload configuration:
			<DIR>
				<LI>maxChunkSize: put your server maxUploadSize (typically: 2Mb).
				<LI>maxFileSize: leave it empty.
				<LI>maxNonTransformedPictureSize: put a value larger than your picture max width and height (for 
				instance 4000) to prevent the applet to work on pictures that you want to upload 'as is'. Pictures 
				bigger than this limit will still be resized, before upload, to the maxPictureSize (in pixels) 
				defined in your gallery. 				 
			</DIR>
		</DIR>
	<LI><B>Standard configuration</B>. This configuration is the standard one, as it is compatible with all 
	existing configurations. It good enough for small upload (e.g.: less than 10 to 20 pictures). 
	<BR>Here is a descripion of what will happen if you do not update any
	JUpload parameters, relevant to the way upload works. The maximum picture/file size is controled these two  
	Coppermine configuration parameters: maxFileSize and maxPictureSize. 
		<DIR>
			<LI>In Coppermine configuration, put a value representative of the real maxFileSize you want to 
			allow.
			<LI>In Jupload configuration:
			<DIR>
				<LI>maxChunkSize: empty. All files are uploaded in one piece.
				<LI>maxFileSize: emptu. Respects the Coppermine maxFileSize configuration.
				<LI>maxNonTransformedPictureSize: empty. Pictures bigger than the Coppermine maxPictureSize are 
				resized before upload. This can take time, when you upload a lot of pictures, as Java is not as 
				good as native librairies (as GD) for heavy CPU work.		 
			</DIR>
		</DIR>
</DIR>
<U>Note: if you prepare your pictures before upload</U> and your pictures are already resized to your gallery
maximum width and height, then the above parameters should work the same way... Let the default parameters...

<HR>

EOS
;



//####################################################################################################
//#################################    FUNCTIONS    ##################################################
//####################################################################################################

/**
 * mergePostDataWithConfig will read post data, and store them into the $JUPLOAD_CONFIG array.
 *
function mergePostDataWithConfig() {
	global $JUploadParamList, $JUPLOAD_CONFIG;

	$htmlResult = '';
	
	//We read the post data. From them, we only take care of the parameters defined in the $JUploadParamList array.
	//But we parse all incoming post data, to display warning if unknown values are coming. These unknown values
	//should only come from bugs. Nobody in the whole world would try to attack a web server ...   ;-)
	foreach ($_POST as $key => $value) {
		//We've read one key. Is it a valid parameter ?
		$validParameter = false;
		foreach ($JUploadParamList as $param) {
			if ($param['name'] == $key) {
				$validParameter = true;
				if ($param['type'] == 'int') {
					//We leave empty values ... empty.
					if ($value != '') {
						$JUPLOAD_CONFIG[$param['name']] = (int) $value;
					}
				} else {
					//Let's manage it as a string. We don't take particular precaution: if the user go to this part
					//of code, then he is an admin. So he can already upload any plugin, that is .. any code.
					$JUPLOAD_CONFIG[$param['name']] = $value;
				}
			}
		}//foreach($JUploadParamList)
		
		//Did we find the parameter ?
		if (!$validParameter) {
			$htmlResult .= "<BR>The post variable '<B>$key</B>' is not a valid parameter for this version of JUpload.";
		}
	}//foreach($_POST)
	
	return $htmlResult;
}
*/

/**
 * writeJuploadConfigFile generates the Jupload config file from the posted data.
 */
 
function getTableOfContent() {
	global $JUploadParamList;

	$return = "";
	$return .= "<B>Table of content:</B>\n";
	$return .= " <DIR>\n";
	$return .= "  <LI><a href='#Hints'>Configuration hints</a>\n";
	foreach ($JUploadParamList as $param) {
		$return .= "  <LI><a href='#${param['name']}'>config parameter <I>${param['name']}</I></a>\n";
	}
	$return .= " </DIR>\n";
	
	return $return;
}//getTableOfContent


function writeJuploadConfigFile() {
	global $JUploadParamList, $JUPLOAD_CONFIG, $configFileHeader, $hint;
	$htmlResult = '';  //This string will remain empty if everything is Ok.

	$filename = 'plugins/jupload/user/config.inc.php';
	$h = fopen($filename, 'w');

	if (!$h) {
		$htmlResult = "<FONT color=red>Erreur while opening the file '$filename'</FONT>";
	} else {
		$dateTime = date('j M Y  H:i');
		fwrite($h, $configFileHeader);
		//Then, we write the list of parameters, a kind of 'table of content', to allows quick 
		//access to each parameter
		fwrite($h, "/*\n");
		fwrite($h, getTableOfContent());
		fwrite($h, "*/\n");
		fwrite($h, <<<EOS

/*
$hint
*/

EOS
);


		foreach ($JUploadParamList as $param) {
			//Default value: a beautiful empty string!
			$comment_if_undefined = '//';
			$val = '';			
			if ($param['type'] == 'int') {				
				if (isset($_POST[$param['name']])  &&  $_POST[$param['name']] != '') {
					$val = (int)$_POST[$param['name']];
					$comment_if_undefined = '';
				}
			} else if ($param['type'] == 'float') {
				if (isset($_POST[$param['name']])  &&  $_POST[$param['name']] != '') {
					$val = (float)$_POST[$param['name']];
					$comment_if_undefined = '';
				}
			} else {
				//Let's suppose it's a string
				if (isset($_POST[$param['name']])  &&  $_POST[$param['name']] != '') {
					$val = '\'' . $_POST[str_replace('\'', '\\\'', $param['name'])] . '\'';
					$comment_if_undefined = '';
				}
			}

			fwrite($h, <<<EOS
/*
${param['desc']}
Default value is '${param['default']}'		
*/
$comment_if_undefined\$JUPLOAD_CONFIG['${param['name']}'] = $val;



EOS
);
		}
	}
	
	return $htmlResult;
}




///////////////////////////////////////////////////////////////////////
/////////////////   MANAGEMENT OF POST DATA        ////////////////////
///////////////////////////////////////////////////////////////////////

if ($action == 'store_config') {
	//$htmlPostResult = mergePostDataWithConfig();
	$htmlWriteConfigResult = writeJuploadConfigFile();
}

///////////////////////////////////////////////////////////////////////
///   RELOAD DATA, TO DISTINGUISH REAL VALUES FROM DEFAULT VALUES    //
///////////////////////////////////////////////////////////////////////
//We clear the calculated config
unset($JUPLOAD_CONFIG);
//Then, we load exactly the content of the config file (or nothing, if it doesn't exist)
$config_inc = $juploadRootDirectory . 'user/config.inc.php';
if (file_exists($config_inc)) { 
	require($config_inc);
}


///////////////////////////////////////////////////////////////////////
///////////////   GENERATION OF THE HTML CONTENT    ///////////////////
///////////////////////////////////////////////////////////////////////

pageheader('JUpload configuration');

echo ('<form method="post" name="form_album" enctype="multipart/form-data" action="index.php?file=jupload/jupload&action=store_config">');
	starttable('100%', 'JUpload configuration', 2);
		if (isset($htmlPostResult)) {
			form_statement ("<FONT color=red>An error occured: $htmlPostResult</FONT>");
		}
		if ($htmlWriteConfigResult != '') {
			form_statement ("<FONT color=red>An error occured: $htmlWriteConfigResult</FONT>");
		}
		
		//First: the table of content, to access directly to each parameters
		form_statement (getTableOfContent());
		
		//Let's display some help.		
		form_statement ($hint);		
		
		//Then, the list of parameters, with: name, description, 
		foreach ($JUploadParamList as $param) {			
			form_statement ("<B><a name='${param['name']}'>${param['name']}</a></B>");		
			form_statement ($param['desc']);		
			form_statement ("Default value is '${param['default']}'");		
			text_box_input(	$param['name'], 
							$param['name'], 
							255, 
							1, 
							isset($JUPLOAD_CONFIG[$param['name']]) ? $JUPLOAD_CONFIG[$param['name']] : ''
							); 
			form_statement ('<BR>');		
		}
	
		$submit_buttons = array (
			    array('value' => 'Store configuration'),
		    );
		submit_button($submit_buttons);
	endtable();
echo ("</form>");
pagefooter();
//ob_end_flush();
